/*
Copyright (c) 2008 Frank Condello
http://www.chaoticbox.com
*/

var cprefix = '';
var infoprefix = 'o_';
var tocsuffix = '_TOC';

function cookieSet(cname, val) {
	if (cname.search(tocsuffix) == cname.length-tocsuffix.length) {
		document.cookie = cname+'='+val;
	} else {
		document.cookie = cprefix + cname+'='+val;
	}
}


function flashBackgroundColor(ele, colnow, colnext, rep) {
	var targ = document.getElementById(ele);
	if (targ) {
		targ.style.backgroundColor = colnow;
		if (rep < 8) {
			setTimeout('flashBackgroundColor("'+ele+'","'+colnext+'","'+colnow+'",'+(rep+1)+')', 120);
		}
	}
}


function jumpTo(anc) {
	var targ = document.getElementById(infoprefix+anc);
	if (targ) {
		if (targ.style.display != 'block') {
			targ.style.display = 'block';
			cookieSet(infoprefix+anc, 'block');
		}
		location.hash = anc;
		location.replace(location);
		targ.style.backgroundColor = '#ffff99';
		setTimeout('flashBackgroundColor("'+infoprefix+anc+'","#fffff4","#ffff99",0)', 750);
	}
}


function collapsibleToggle(divid) {
	var targ = document.getElementById(divid);
	if (targ) {
		if (targ.style.display == 'block') {
			targ.style.display = 'none';
			cookieSet(divid, 'none');
		} else {
			targ.style.display = 'block';
			cookieSet(divid, 'block');
		}
	}
}


function showAll(divid) {
	var targ = document.getElementById(divid);
	if (targ) {
		var panes = targ.getElementsByTagName('div');
		if (panes) {
			for (var i = 0; i < panes.length; i++) { 
				panes[i].style.display = 'block';
				cookieSet(panes[i].id, 'block');
			}
		}
	}
}


function collapseAll(divid) {
	var targ = document.getElementById(divid);
	if (targ) {
		var panes = targ.getElementsByTagName('div');
		for (var i = 0; i < panes.length; i++) { 
			panes[i].style.display = 'none';
			cookieSet(panes[i].id, 'none');
		}
	}
}


function collapsiblesRestoreAll() {
	
	var clnks = document.getElementsByTagName('a');
	var gotv = false;
	for (var i=0;i < clnks.length;i++) {
		var a = clnks[i];
		if (a.className == 'mlink') {
			var id = a.innerHTML;
			if (id) {
				if (id.match('Version ')) {
					var aname = infoprefix + 'v'+id.split(' ',2)[1];
					a.onclick = function(){ collapsibleToggle( infoprefix + 'v'+this.innerHTML.split(' ',2)[1] );return false; };
					if (!gotv) {
						gotv = true;
						if (!document.cookie.match(cprefix+aname)) {
							var targ = document.getElementById( aname );
							if (targ) { targ.style.display = 'block'; }
							cookieSet(aname, 'block');
						}
					}
				} else {
					a.onclick = function(){ collapsibleToggle( infoprefix + this.innerHTML.replace(' ','_').replace(/<!--/,'').replace(/-->/,'') );return false; };
				}
			}
		}
	}
	
	var loc = '';
	if ( location.href.match('#') ) {
		loc = location.href.slice( 0, location.href.lastIndexOf('#') );
	} else {
		loc = location.href;	
	}
	
	for (var i=0;i < document.links.length;i++) {
		var anc = document.links[i];
		if ( anc.href.match('#') && (anc.href.indexOf('#') < anc.href.length-1) ) {
			if ( unescape( anc.href.slice(0, anc.href.lastIndexOf('#') ) ) == unescape( loc ) ) {
				anc.onclick = function(){ jumpTo( this.href.slice( this.href.indexOf('#')+1, this.href.length) );return false; };
			}
		}
	}
		
	var ca = document.cookie.split('; ');
	for (var i=0;i < ca.length;i++) {
		var c = ca[i];
		var targ = '';
		if ( c.search(cprefix) == 0 ) {
			targ = document.getElementById( c.slice( cprefix.length, c.indexOf('=') ) );
		} else {
			targ = document.getElementById( c.slice( 0, c.indexOf('=') ) );
		}
		if (targ) {
			targ.style.display = c.slice( c.indexOf('=')+1, c.length );
		}
	}
	
	var jta = location.hash.substring(1)
	if (jta) { jumpTo(jta); }
	
}

{
	if(document.getElementById) {
  	 document.write('<style type="text/css">.collapsible{display:none;}</style>');
	}

	cprefix = location.pathname.slice( location.pathname.lastIndexOf('/')+1, location.pathname.lastIndexOf('.') ) + '_';
	window.onload = collapsiblesRestoreAll;
}
